-- **************************************************************************
-- * TitanPals.lua
-- *
-- * By: Nagdand
-- *       (Nagdand@Laughing Skull)
-- **************************************************************************

-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)

-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPals_Init()
-- DESC : For first time addon use
-- **************************************************************************
function TitanPanelPals_Init()
     if ( not TitanPals or TitanPals == nil ) then TitanPals = {}; end
     if ( not TitanPals["Init"] or TitanPals["Init"] == nil ) then
	  TitanPals["Debug"] = false; --Debug
	  TitanPals["DebugEvent"] = false; --DebugEvent
	  TitanPals["DebugLogEvent"] = false; --DebugLogEvent
          TitanPals["ShowOffline"] = false; --ShowOffline
	  TitanPals["ShowIgnored"] = false; --ShowIgnored
	  TitanPals["ShowClass"] = true; --ShowClass
	  TitanPals["ShowNote"] = false; --ShowNote
	  TitanPals["ShowMem"] = true; --ShowMem
	  TitanPals["NoAlts"] = true; --NoAlts
	  TitanPals["UpDateDB"] = true; --UpDateDB
	  TitanPals["DisplayB"] = true; --DisplayB
	  TitanPals["dLine"] = ""; --dLine
	  TitanPals["Lists"] = {}; --Lists
	  TitanPals["Temp"] = {}; --Temp
	  TitanPals["Alts"] = {}; --Alts
	  TitanPals["DBVer"] = {}; --DBVer
  	  TitanPals["Init"] = true; --Init
	  TitanPals["Right"] = "!l!p"; -- Tooltip right
	  TitanPals["Left"] = "!z"; -- Tooltip left
     end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnEvent()
-- DESC : Event Handler
-- **************************************************************************
function TitanPanelPalsButton_OnEvent(self, event, ...)
     if ( TitanPals["DebugEvent"] ) then TitanPanelPals_DebugUtils("bug", "OnEvent", "["..TitanPanelPals_ColorUtils("GetCText", "gray", event).."]"); end
     local Fac = UnitFactionGroup("player");
     local Rea = GetCVar("realmName");
     local Pla = GetUnitName("player");
     local Lev = UnitLevel("player");
     local Cla = UnitClass("player");
     TitanPanelButton_UpdateButton(LB["TITAN_PALS_CORE_ID"]);	
     TitanPanelButton_UpdateTooltip();
     if ( event == "VARIABLES_LOADED" ) then
          if ( not TitanPals["Player"] or TitanPals["Player"] ~= Pla ) then TitanPals["Player"] = Pla; end
	  if ( not TitanPals["faction"] or TitanPals["Faction"] ~= Fac ) then TitanPals["Faction"] = Fac; end
          if ( not TitanPals["Level"] or TitanPals["Level"] ~= Lev ) then TitanPals["Level"] = Lev; end
	  if ( not TitanPals["Class"] or TitanPals["Class"] ~= Cla ) then TitanPals["Class"] = Cla; end
	  if ( not TitanPals["Realm"] or TitanPals["Realm"]~= Rea ) then TitanPals["Realm"] = Rea; end
	  if ( not palsDB or palsDB ~= Fac..":"..Rea ) then palsDB = Fac..":"..Rea; end
          if ( not TitanPals["Lists"][palsDB] ) then TitanPals["Lists"][palsDB] = {}; end
	  if ( TitanPals["Lists"][palsDB][Pla] ) then TitanPals["Lists"][palsDB][Pla] = Lev..":"..Cla..":na"; end
  	  if ( not TitanPals["Alts"][palsDB] ) then TitanPals["Alts"][palsDB] = {}; end
       	  if ( not TitanPals["Alts"][palsDB][Pla] ) then TitanPals["Alts"][palsDB][Pla] = Pla; end
          if ( not TitanPals["DBVer"] or TitanPals["DBVer"] == nil ) then TitanPals["DBVer"] = {}; end
          if ( not TitanPals["DBVer"][palsDB] or TitanPals["DBVer"][palsDB] ~= LB["TITAN_PALS_CORE_DBVER"] ) then 
               TitanPanelPals_FixArray();
          end
	  if ( TitanPals["DisplayB"] ) then
	       TitanPanelPals_DebugUtils("info", "load", "Titan Panel [|cffeda55fPals|r] |cff00aa00"..LB["TITAN_PALS_CORE_VERSION"].."|r Loaded...")
	       TitanPanelPals_CoreUtils("mem");
	  end
     elseif ( event == "PLAYER_REGEN_DISABLED" ) then TitanPals["UpDateDB"] = false;
     elseif ( event == "PLAYER_REGEN_ENABLED" ) then TitanPals["UpDateDB"] = true;
     --[[elseif ( event == "FRIENDLIST_UPDATE" ) then
          if ( TitanPals["UpDateDB"] == true ) then
               TitanPanelPals_DebugUtils("bug", "UpDateDB", "UpDateDB in progress.")
               TitanPanelPals_CoreUtils("UpDate", Fac, Rea, Pal);
          end ]]--
     end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_GetButtonText()
-- DESC : Build Button Text
-- **************************************************************************
function TitanPanelPalsButton_GetButtonText()
	local NumIgnore = GetNumIgnores();
	local CurCounts = TitanPanelPals_GetButtonCounts();
	local NumPals, NumPalsOnline = string.match( CurCounts, '(.*):(.*)' )
	-- create string for Titan bar display
	local buttonRichText = format(LB["TITAN_PALS_BUTTON_TEXT"], TitanPanelPals_ColorUtils("GetCText", "green", NumPalsOnline), TitanPanelPals_ColorUtils("GetCText", "hlight", NumPals), TitanPanelPals_ColorUtils("GetCText", "red", NumIgnore));
	return LB["TITAN_PALS_BUTTON_LABEL"], buttonRichText;
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnClick()
-- DESC : Toggles Friends Dialog
-- **************************************************************************
function TitanPanelPalsButton_OnClick(self, button)
	if ( button == "LeftButton" ) then
		ToggleFriendsFrame(1);
	else
		TitanPanelButton_OnClick(self, button);
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_GetButtonCounts()
-- DESC : Counts Friends, Ignored and Online for Button Text
-- **************************************************************************

function TitanPanelPals_GetButtonCounts()
	local np = GetNumFriends();
	local npo = 0;
	local pn, pl, pc, pa, pco, ps, pno, fI
	-- get a count of the number of online friends
	for fI=1, np do
		pn, pl, pc, pa, pco, ps, pno = GetFriendInfo(fI);
		if ( pco ) then npo = npo + 1; end
	end
	return np..":"..npo;
end


-- **************************************************************************
-- NAME : TitanPanelPals_SyncAlts()
-- DESC : This adds your alts to your friends list for things like mailing
-- **************************************************************************
function TitanPanelPals_SyncAlts()
     -- Alts to Pals List Syncing
     local np = GetNumFriends();
     local aIndex = TitanPals["Alts"][palsDB];
     local fI, palsn, palsl, palsc, palsa, palsco, palss, palsno;
     TitanPals["UpDateDB"] = false;
     for n, v in pairs(aIndex) do
          TitanPanelPals_DebugUtils("bug", "SyncAlts", "n = "..n);
          local tp = 0;
          local fI;
          for fI=1, np do
               palsn, palsl, palsc, palsa, palsco, palss, palsno = GetFriendInfo(fI);
               if ( n == palsn ) then tp = 1; end
          end
          if ( tp == 0 and n ~= TitanPals["Player"] ) then
               TitanPanelPals_DebugUtils("info", "SyncAlts", "Adding Alt "..n.." to firends list");
               AddFriend(n); 
          end
     end
     TitanPanelPals_DebugUtils("info", "Sybc Alts", "Sync Finished.");
     TitanPals["UpDateDB"] = true;
end

-- **************************************************************************
-- NAME : TitanPanelPals_SyncAlts()
-- DESC : This syncs your alts friend to your friends list
-- **************************************************************************

function TitanPanelPals_SyncAltsFriends()
     local np = GetNumFriends();
     local iTable = TitanPals["Lists"][palsDB];
     local palsn, palsl, palsc, palsa, palsco, palss, palsno;
     TitanPals["UpDateDB"] = false;
     for n,v in pairs(iTable) do
          if ( n ~= TitanPals["Player"] ) then
               TitanPanelPals_DebugUtils("info", "Sync", "Syncing Alts Friends from : "..n);
               local v2, v3 = string.match(n, '(.*):(.*)');
               local tp = 0;
               local fI;
               for fI=1, np do
                    palsn, palsl, palsc, palsa, palsco, palss, palsno = GetFriendInfo(fI);
                    if ( n == palsn ) then tp = 1; end
               end
               if ( tp == 0 and n ~= TitanPals["Player"] ) then
                    TitanPanelPals_DebugUtils("info", "SyncAltsFriends", "Adding "..n.."("..v..") to friends list");
                    AddFriend(n);
               end
	  end
     end
     TitanPanelPals_DebugUtils("info", "Sybc Alts", "Sync Finished.");
     TitanPals["UpDateDB"] = true;
end